<template>
    <div>
        <div v-if="current">
            <ob-table
                :columns="parameters"
                :items="gridData"
                :addButtonText="'Добавить параметр'"
                :functionalPanel="true"
                :showAddButton="true"
                @select="selectHandler"
                @add="openPopup()"
            />
            
            <div class="table">
                <p class="table__header">{{quality}}</p>
                <ob-input
                    class="table__item"
                    :label="'Удовлетворительно'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="table__item"
                    :label="'Хорошо'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="table__item"
                    :label="'Отлично'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
            </div>
            <div class="table">
                <p class="table__header">{{fresh}}</p>
                <ob-input
                    class="table__item"
                    :label="'Совсем недавно'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="table__item"
                    :label="'Не так давно'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
                <ob-input
                    class="table__item"
                    :label="'Совсем давно'"
                    :placeholder="'Введите значение'"
                    type="text"
                />
            </div>
            <!-- <table-rate :header="quality" :items="rating"/>
            <table-rate :header="fresh" :items="times"/> -->
        </div>
        <parameter-standart ref="constructorPopup" v-if="current"/>
    </div>
</template>

<script>
// import DataGrid from 'common-components/src/obComponents/obDataGrid';
import ObTable from "common-components/src/obComponents/obTable";
import ObInput from 'common-components/src/obComponents/obInput'
// import tableRate from '../common/table';
import parameterStandart from './parameterStandart';
import { GET_PARAMS } from '../../../store/modules/parameter';

export default {
    components: {
        // DataGrid,
        ObTable,
        ObInput,
        // tableRate,
        parameterStandart
    },
    data() {
        return {
            quality: 'Пороги рейтинга для отображения качественной оценки',
            fresh: 'Критерии свежести данных',
            parameters: [
                {
                    title: 'Период',
                    key: 'period',
                    fixed: true
                },
                {
                    title: 'Вес',
                    key: 'weight',
                    width: 100
                },
            ],
            rating: [
                {
                    value: 'Удовлетворительно'
                },
                {
                    value: 'Хорошо'
                },
                {
                    value: 'Отлично'
                }
            ],
            times: [
                {
                    value: 'Совсем недавно'
                },
                {
                    value: 'Не так давно'
                },
                {
                    value: 'Совсем давно'
                }
            ],
            // gridData: undefined
        }
    },
    computed: {
        gridData() {
            const data = this.$store.getters.getParams;
            const preparedData = [];
            for (let i = 0; i < data.length; i++) {
                const item = data[i];
                if (item.parameter.type === "SIMPLE") {
                    for (let j = 0; j < item.value.ranges.length; j++) {
                        const points = item.value.ranges[j];
                        preparedData.push({
                            period: points.from + '-' +  points.to,
                            weight: points.point, 
                        });
                    }
                } else if (item.parameter.type === "HARD") {
                    for (let j = 0; j < item.value.pointRanges.length; j++) {
                        const points = item.value.pointRanges[j];
                        preparedData.push({
                            period: points.from + '-' +  points.to,
                            weight: points.point, 
                        });
                    }
                } else if (item.parameter.type === ("BINARY" || "EXCLUDE")) {
                    console.log('BINARY or EXCLUDE')
                } else {
                    console.log('no data')
                }
            }
            return preparedData;
        },
        current() {
            return this.$store.getters.getCurrentMethodology;
        },
    },
    watch: {
        current() {
            this.current.uuid && this.$store.dispatch(GET_PARAMS, this.current.uuid)
            // this.gridData = this.$store.getters.getParams;
            console.log('gridData');
            console.log(this.gridData);
        }
    },
    methods: {
        openPopup(uuid) {
            // console.log(this.$refs)
            // console.log(this.$refs['constructorPopup'])
            this.$refs['constructorPopup'].open(uuid);
        },
        selectHandler(data) {
            // this.$store.dispatch(GET_PARAMS, data.uuid)
            console.log('selected')
            console.log(data)
        }
    }
}
</script>

<style lang="scss" scoped>
.table {
    padding: 10px 0;
    display: flex;
    flex-wrap: wrap;
    width: 100%;
    &__item {
        width: 33.33%;
        padding: 10px 0;
    }
    &__header {
        width: 100%;
    }
}
</style>
